Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4671)
@@ -3615,24 +3687,26 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-
-             st = water_type_f%var(j,i)
-             IF ( st /= water_type_f%fill  .AND.  st /= 0 )  THEN
-                IF ( TRIM( initializing_actions ) /= 'read_restart_data' )     &
-                   t_soil_h%var_2d(:,m) = water_pars(ind_w_temp,st)
-                surf_lsm_h%z0(m)     = water_pars(ind_w_z0,st)
-                surf_lsm_h%z0h(m)    = water_pars(ind_w_z0h,st)
-                surf_lsm_h%z0q(m)    = water_pars(ind_w_z0h,st)
-                surf_lsm_h%lambda_surface_s(m) = water_pars(ind_w_lambda_s,st)
-                surf_lsm_h%lambda_surface_u(m) = water_pars(ind_w_lambda_u,st)
-                surf_lsm_h%c_surface(m)        = 0.0_wp
-                surf_lsm_h%albedo_type(m,ind_wat_win) = INT( water_pars(ind_w_at,st) )
-                surf_lsm_h%emissivity(m,ind_wat_win)  = water_pars(ind_w_emis,st)
-
-                surf_lsm_h%water_type(m)      = st
-                surf_lsm_h%water_type_name(m) = water_type_name(st)
-             ENDIF
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+
+                st = water_type_f%var(j,i)
+                IF ( st /= water_type_f%fill  .AND.  st /= 0 )  THEN
+                   IF ( TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                      t_soil_h(l)%var_2d(:,m) = water_pars(ind_w_temp,st)
+                   surf_lsm_h(l)%z0(m)     = water_pars(ind_w_z0,st)
+                   surf_lsm_h(l)%z0h(m)    = water_pars(ind_w_z0h,st)
+                   surf_lsm_h(l)%z0q(m)    = water_pars(ind_w_z0h,st)
+                   surf_lsm_h(l)%lambda_surface_s(m) = water_pars(ind_w_lambda_s,st)
+                   surf_lsm_h(l)%lambda_surface_u(m) = water_pars(ind_w_lambda_u,st)
+                   surf_lsm_h(l)%c_surface(m)        = 0.0_wp
+                   surf_lsm_h(l)%albedo_type(m,ind_wat_win) = INT( water_pars(ind_w_at,st) )
+                   surf_lsm_h(l)%emissivity(m,ind_wat_win)  = water_pars(ind_w_emis,st)
+
+                   surf_lsm_h(l)%water_type(m)      = st
+                   surf_lsm_h(l)%water_type_name(m) = water_type_name(st)
+                ENDIF
+             ENDDO
           ENDDO
 !
@@ -3675,53 +3749,55 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-!
-!--          If surface element is not a water surface and any value in
-!--          water_pars is given, neglect this information and give an
-!--          informative message that this value will not be used.
-             IF ( .NOT. surf_lsm_h%water_surface(m)  .AND.                     &
-                   ANY( water_pars_f%pars_xy(:,j,i) /= water_pars_f%fill ) )  THEN
-                WRITE( message_string, * )                                     &
-                              'surface element at grid point (j,i) = (',       &
-                              j, i, ') is not a water surface, ',              &
-                              'so that information given in ',                 &
-                              'water_pars at this point is neglected.'
-                CALL message( 'land_surface_model_mod', 'PA0645', 0, 0, myid, 6, 0 )
-             ELSE
-                IF ( water_pars_f%pars_xy(ind_w_temp,j,i) /=                   &
-                     water_pars_f%fill  .AND.                                  &
-                     TRIM( initializing_actions ) /= 'read_restart_data' )     &
-                      t_soil_h%var_2d(:,m) = water_pars_f%pars_xy(ind_w_temp,j,i)
-
-                IF ( water_pars_f%pars_xy(ind_w_z0,j,i) /= water_pars_f%fill ) &
-                   surf_lsm_h%z0(m)     = water_pars_f%pars_xy(ind_w_z0,j,i)
-
-                IF ( water_pars_f%pars_xy(ind_w_z0h,j,i) /= water_pars_f%fill )&
-                THEN
-                   surf_lsm_h%z0h(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
-                   surf_lsm_h%z0q(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+   !
+   !--          If surface element is not a water surface and any value in
+   !--          water_pars is given, neglect this information and give an
+   !--          informative message that this value will not be used.
+                IF ( .NOT. surf_lsm_h(l)%water_surface(m)  .AND.                     &
+                      ANY( water_pars_f%pars_xy(:,j,i) /= water_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                     &
+                                 'surface element at grid point (j,i) = (',       &
+                                 j, i, ') is not a water surface, ',              &
+                                 'so that information given in ',                 &
+                                 'water_pars at this point is neglected.'
+                   CALL message( 'land_surface_model_mod', 'PA0645', 0, 0, myid, 6, 0 )
+                ELSE
+                   IF ( water_pars_f%pars_xy(ind_w_temp,j,i) /=                   &
+                        water_pars_f%fill  .AND.                                  &
+                        TRIM( initializing_actions ) /= 'read_restart_data' )     &
+                         t_soil_h(l)%var_2d(:,m) = water_pars_f%pars_xy(ind_w_temp,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_z0,j,i) /= water_pars_f%fill ) &
+                      surf_lsm_h(l)%z0(m)     = water_pars_f%pars_xy(ind_w_z0,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_z0h,j,i) /= water_pars_f%fill )&
+                   THEN
+                      surf_lsm_h(l)%z0h(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                      surf_lsm_h(l)%z0q(m)    = water_pars_f%pars_xy(ind_w_z0h,j,i)
+                   ENDIF
+                   IF ( water_pars_f%pars_xy(ind_w_lambda_s,j,i) /=               &
+                        water_pars_f%fill )                                       &
+                      surf_lsm_h(l)%lambda_surface_s(m) =                            &
+                                           water_pars_f%pars_xy(ind_w_lambda_s,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_lambda_u,j,i) /=               &
+                         water_pars_f%fill )                                      &
+                      surf_lsm_h(l)%lambda_surface_u(m) =                            &
+                                           water_pars_f%pars_xy(ind_w_lambda_u,j,i)
+
+                   IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                     &
+                        water_pars_f%fill )                                       &
+                      surf_lsm_h(l)%albedo_type(m,ind_wat_win) =                     &
+                                          INT( water_pars_f%pars_xy(ind_w_at,j,i) )
+
+                   IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                   &
+                        water_pars_f%fill )                                       &
+                      surf_lsm_h(l)%emissivity(m,ind_wat_win) =                      &
+                                             water_pars_f%pars_xy(ind_w_emis,j,i)
                 ENDIF
-                IF ( water_pars_f%pars_xy(ind_w_lambda_s,j,i) /=               &
-                     water_pars_f%fill )                                       &
-                   surf_lsm_h%lambda_surface_s(m) =                            &
-                                        water_pars_f%pars_xy(ind_w_lambda_s,j,i)
-
-                IF ( water_pars_f%pars_xy(ind_w_lambda_u,j,i) /=               &
-                      water_pars_f%fill )                                      &
-                   surf_lsm_h%lambda_surface_u(m) =                            &
-                                        water_pars_f%pars_xy(ind_w_lambda_u,j,i)
-
-                IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                     &
-                     water_pars_f%fill )                                       &
-                   surf_lsm_h%albedo_type(m,ind_wat_win) =                     &
-                                       INT( water_pars_f%pars_xy(ind_w_at,j,i) )
-
-                IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                   &
-                     water_pars_f%fill )                                       &
-                   surf_lsm_h%emissivity(m,ind_wat_win) =                      &
-                                          water_pars_f%pars_xy(ind_w_emis,j,i)
-             ENDIF
+             ENDDO
           ENDDO
 !
@@ -3844,39 +3920,41 @@
 !--    Level 1 initialization of pavement type surfaces. Horizontally
 !--    homogeneous characteristics are assumed
-       surf_lsm_h%nzt_pavement = pavement_depth_level
-       DO  m = 1, surf_lsm_h%ns
-          IF ( surf_lsm_h%pavement_surface(m) )  THEN
-             surf_lsm_h%nzt_pavement(m)        = nzt_pavement
-             surf_lsm_h%z0(m)                  = z0_pavement
-             surf_lsm_h%z0h(m)                 = z0h_pavement
-             surf_lsm_h%z0q(m)                 = z0q_pavement
-             surf_lsm_h%lambda_surface_s(m)    = pavement_heat_conduct         &
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
-             surf_lsm_h%lambda_surface_u(m)    = pavement_heat_conduct         &
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
-             surf_lsm_h%c_surface(m)           = pavement_heat_capacity        &
-                                                        * dz_soil(nzb_soil)    &
-                                                        * 0.25_wp
-
-             surf_lsm_h%albedo_type(m,ind_pav_green) = albedo_type
-             surf_lsm_h%emissivity(m,ind_pav_green)  = emissivity
-
-             surf_lsm_h%pavement_type(m)      = pavement_type
-             surf_lsm_h%pavement_type_name(m) = pavement_type_name(pavement_type)
-
-             IF ( pavement_type /= 0 )  THEN
-                DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
-                   surf_lsm_h%lambda_h_def(k,m)    =                           &
-                                     pavement_subsurface_pars_1(k,pavement_type)
-                   surf_lsm_h%rho_c_total_def(k,m) =                           &
-                                     pavement_subsurface_pars_2(k,pavement_type)
-                ENDDO
-             ELSE
-                surf_lsm_h%lambda_h_def(:,m)     = pavement_heat_conduct
-                surf_lsm_h%rho_c_total_def(:,m)  = pavement_heat_capacity
+       DO  l = 0, 1
+          surf_lsm_h(l)%nzt_pavement = pavement_depth_level
+          DO  m = 1, surf_lsm_h(l)%ns
+             IF ( surf_lsm_h(l)%pavement_surface(m) )  THEN
+                surf_lsm_h(l)%nzt_pavement(m)        = nzt_pavement
+                surf_lsm_h(l)%z0(m)                  = z0_pavement
+                surf_lsm_h(l)%z0h(m)                 = z0h_pavement
+                surf_lsm_h(l)%z0q(m)                 = z0q_pavement
+                surf_lsm_h(l)%lambda_surface_s(m)    = pavement_heat_conduct         &
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                surf_lsm_h(l)%lambda_surface_u(m)    = pavement_heat_conduct         &
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                surf_lsm_h(l)%c_surface(m)           = pavement_heat_capacity        &
+                                                           * dz_soil(nzb_soil)    &
+                                                           * 0.25_wp
+
+                surf_lsm_h(l)%albedo_type(m,ind_pav_green) = albedo_type
+                surf_lsm_h(l)%emissivity(m,ind_pav_green)  = emissivity
+
+                surf_lsm_h(l)%pavement_type(m)      = pavement_type
+                surf_lsm_h(l)%pavement_type_name(m) = pavement_type_name(pavement_type)
+
+                IF ( pavement_type /= 0 )  THEN
+                   DO  k = nzb_soil, surf_lsm_h(l)%nzt_pavement(m)
+                      surf_lsm_h(l)%lambda_h_def(k,m)    =                           &
+                                        pavement_subsurface_pars_1(k,pavement_type)
+                      surf_lsm_h(l)%rho_c_total_def(k,m) =                           &
+                                        pavement_subsurface_pars_2(k,pavement_type)
+                   ENDDO
+                ELSE
+                   surf_lsm_h(l)%lambda_h_def(:,m)     = pavement_heat_conduct
+                   surf_lsm_h(l)%rho_c_total_def(:,m)  = pavement_heat_capacity
+                ENDIF
              ENDIF
-          ENDIF
+          ENDDO
        ENDDO
 
@@ -3926,50 +4004,52 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-
-             st = pavement_type_f%var(j,i)
-             IF ( st /= pavement_type_f%fill  .AND.  st /= 0 )  THEN
-!
-!--             Determine deepmost index of pavement layer
-                DO  k = nzb_soil, nzt_soil
-                   IF ( pavement_subsurface_pars_1(k,st) == 9999999.9_wp       &
-                   .OR. pavement_subsurface_pars_2(k,st) == 9999999.9_wp)      &
-                   THEN
-                      surf_lsm_h%nzt_pavement(m) = k-1
-                      EXIT
-                   ENDIF
-                ENDDO
-
-                surf_lsm_h%z0(m)                = pavement_pars(ind_p_z0,st)
-                surf_lsm_h%z0h(m)               = pavement_pars(ind_p_z0h,st)
-                surf_lsm_h%z0q(m)               = pavement_pars(ind_p_z0h,st)
-
-                surf_lsm_h%lambda_surface_s(m)  =                              &
-                                              pavement_subsurface_pars_1(0,st) &
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
-                surf_lsm_h%lambda_surface_u(m)  =                              &
-                                              pavement_subsurface_pars_1(0,st) &
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
-                surf_lsm_h%c_surface(m)         =                              &
-                                               pavement_subsurface_pars_2(0,st)&
-                                                        * dz_soil(nzb_soil)    &
-                                                        * 0.25_wp
-                surf_lsm_h%albedo_type(m,ind_pav_green) = INT( pavement_pars(ind_p_at,st) )
-                surf_lsm_h%emissivity(m,ind_pav_green)  = pavement_pars(ind_p_emis,st)
-
-                surf_lsm_h%pavement_type(m)      = st
-                surf_lsm_h%pavement_type_name(m) = pavement_type_name(st)
-
-                DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
-                   surf_lsm_h%lambda_h_def(k,m)    =                           &
-                                     pavement_subsurface_pars_1(k,pavement_type)
-                   surf_lsm_h%rho_c_total_def(k,m) =                           &
-                                     pavement_subsurface_pars_2(k,pavement_type)
-                ENDDO
-             ENDIF
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+
+                st = pavement_type_f%var(j,i)
+                IF ( st /= pavement_type_f%fill  .AND.  st /= 0 )  THEN
+   !
+   !--             Determine deepmost index of pavement layer
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( pavement_subsurface_pars_1(k,st) == 9999999.9_wp       &
+                      .OR. pavement_subsurface_pars_2(k,st) == 9999999.9_wp)      &
+                      THEN
+                         surf_lsm_h(l)%nzt_pavement(m) = k-1
+                         EXIT
+                      ENDIF
+                   ENDDO
+
+                   surf_lsm_h(l)%z0(m)                = pavement_pars(ind_p_z0,st)
+                   surf_lsm_h(l)%z0h(m)               = pavement_pars(ind_p_z0h,st)
+                   surf_lsm_h(l)%z0q(m)               = pavement_pars(ind_p_z0h,st)
+
+                   surf_lsm_h(l)%lambda_surface_s(m)  =                              &
+                                                 pavement_subsurface_pars_1(0,st) &
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                   surf_lsm_h(l)%lambda_surface_u(m)  =                              &
+                                                 pavement_subsurface_pars_1(0,st) &
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                   surf_lsm_h(l)%c_surface(m)         =                              &
+                                                  pavement_subsurface_pars_2(0,st)&
+                                                           * dz_soil(nzb_soil)    &
+                                                           * 0.25_wp
+                   surf_lsm_h(l)%albedo_type(m,ind_pav_green) = INT( pavement_pars(ind_p_at,st) )
+                   surf_lsm_h(l)%emissivity(m,ind_pav_green)  = pavement_pars(ind_p_emis,st)
+
+                   surf_lsm_h(l)%pavement_type(m)      = st
+                   surf_lsm_h(l)%pavement_type_name(m) = pavement_type_name(st)
+
+                   DO  k = nzb_soil, surf_lsm_h(l)%nzt_pavement(m)
+                      surf_lsm_h(l)%lambda_h_def(k,m)    =                           &
+                                        pavement_subsurface_pars_1(k,pavement_type)
+                      surf_lsm_h(l)%rho_c_total_def(k,m) =                           &
+                                        pavement_subsurface_pars_2(k,pavement_type)
+                   ENDDO
+                ENDIF
+             ENDDO
           ENDDO
 !
@@ -4036,39 +4116,40 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-!
-!--          If surface element is not a pavement surface and any value in
-!--          pavement_pars is given, neglect this information and give an
-!--          informative message that this value will not be used.
-             IF ( .NOT. surf_lsm_h%pavement_surface(m)  .AND.                  &
-                   ANY( pavement_pars_f%pars_xy(:,j,i) /=                      &
-                   pavement_pars_f%fill ) )  THEN
-                WRITE( message_string, * )                                     &
-                              'surface element at grid point (j,i) = (',       &
-                              j, i, ') is not a pavement surface, ',           &
-                              'so that information given in ',                 &
-                              'pavement_pars at this point is neglected.'
-                CALL message( 'land_surface_model_mod', 'PA0647', 0, 0, myid, 6, 0 )
-             ELSE
-                IF ( pavement_pars_f%pars_xy(ind_p_z0,j,i) /=                  &
-                     pavement_pars_f%fill )                                    &
-                   surf_lsm_h%z0(m)  = pavement_pars_f%pars_xy(ind_p_z0,j,i)
-                IF ( pavement_pars_f%pars_xy(ind_p_z0h,j,i) /=                 &
-                     pavement_pars_f%fill )  THEN
-                   surf_lsm_h%z0h(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
-                   surf_lsm_h%z0q(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+   !
+   !--          If surface element is not a pavement surface and any value in
+   !--          pavement_pars is given, neglect this information and give an
+   !--          informative message that this value will not be used.
+                IF ( .NOT. surf_lsm_h(l)%pavement_surface(m)  .AND.                  &
+                      ANY( pavement_pars_f%pars_xy(:,j,i) /=                      &
+                      pavement_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                     &
+                                 'surface element at grid point (j,i) = (',       &
+                                 j, i, ') is not a pavement surface, ',           &
+                                 'so that information given in ',                 &
+                                 'pavement_pars at this point is neglected.'
+                   CALL message( 'land_surface_model_mod', 'PA0647', 0, 0, myid, 6, 0 )
+                ELSE
+                   IF ( pavement_pars_f%pars_xy(ind_p_z0,j,i) /=                  &
+                        pavement_pars_f%fill )                                    &
+                      surf_lsm_h(l)%z0(m)  = pavement_pars_f%pars_xy(ind_p_z0,j,i)
+                   IF ( pavement_pars_f%pars_xy(ind_p_z0h,j,i) /=                 &
+                        pavement_pars_f%fill )  THEN
+                      surf_lsm_h(l)%z0h(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                      surf_lsm_h(l)%z0q(m) = pavement_pars_f%pars_xy(ind_p_z0h,j,i)
+                   ENDIF
+                   IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=                  &
+                        pavement_pars_f%fill )                                    &
+                      surf_lsm_h(l)%albedo_type(m,ind_pav_green) =                   &
+                                      INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
+                   IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=                &
+                        pavement_pars_f%fill )                                    &
+                      surf_lsm_h(l)%emissivity(m,ind_pav_green)  =                   &
+                                      pavement_pars_f%pars_xy(ind_p_emis,j,i)
                 ENDIF
-                IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=                  &
-                     pavement_pars_f%fill )                                    &
-                   surf_lsm_h%albedo_type(m,ind_pav_green) =                   &
-                                   INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
-                IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=                &
-                     pavement_pars_f%fill )                                    &
-                   surf_lsm_h%emissivity(m,ind_pav_green)  =                   &
-                                   pavement_pars_f%pars_xy(ind_p_emis,j,i)
-             ENDIF
-
+             ENDDO
           ENDDO
 !
@@ -4124,45 +4205,47 @@
 !--       Set pavement depth to nzt_soil. Please note, this is just a
 !--       workaround at the moment.
-          DO  m = 1, surf_lsm_h%ns
-             IF ( surf_lsm_h%pavement_surface(m) )  THEN
-
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-
-                surf_lsm_h%nzt_pavement(m) = nzt_soil
-
-                IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i) &
-                     /= pavement_subsurface_pars_f%fill )  THEN
-                   surf_lsm_h%lambda_surface_s(m)  =                           &
-                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
-                   surf_lsm_h%lambda_surface_u(m)  =                           &
-                      pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
-                                                  * ddz_soil(nzb_soil)         &
-                                                  * 2.0_wp
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                IF ( surf_lsm_h(l)%pavement_surface(m) )  THEN
+
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+
+                   surf_lsm_h(l)%nzt_pavement(m) = nzt_soil
+
+                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i) &
+                        /= pavement_subsurface_pars_f%fill )  THEN
+                      surf_lsm_h(l)%lambda_surface_s(m)  =                           &
+                         pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                      surf_lsm_h(l)%lambda_surface_u(m)  =                           &
+                         pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,0,j,i)&
+                                                     * ddz_soil(nzb_soil)         &
+                                                     * 2.0_wp
+                   ENDIF
+                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i) /= &
+                        pavement_subsurface_pars_f%fill )  THEN
+                      surf_lsm_h(l)%c_surface(m)     =                               &
+                         pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i)   &
+                                                     * dz_soil(nzb_soil)          &
+                                                     * 0.25_wp
+                   ENDIF
+
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i) /= &
+                           pavement_subsurface_pars_f%fill )  THEN
+                         surf_lsm_h(l)%lambda_h_def(k,m) =                              &
+                             pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i)
+                      ENDIF
+                      IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i) /= &
+                           pavement_subsurface_pars_f%fill )  THEN
+                         surf_lsm_h(l)%rho_c_total_def(k,m) =                           &
+                             pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i)
+                      ENDIF
+                   ENDDO
+
                 ENDIF
-                IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i) /= &
-                     pavement_subsurface_pars_f%fill )  THEN
-                   surf_lsm_h%c_surface(m)     =                               &
-                      pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,0,j,i)   &
-                                                  * dz_soil(nzb_soil)          &
-                                                  * 0.25_wp
-                ENDIF
-
-                DO  k = nzb_soil, nzt_soil
-                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i) /= &
-                        pavement_subsurface_pars_f%fill )  THEN
-                      surf_lsm_h%lambda_h_def(k,m) =                              &
-                          pavement_subsurface_pars_f%pars_xyz(ind_p_lambda_h,k,j,i)
-                   ENDIF
-                   IF ( pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i) /= &
-                        pavement_subsurface_pars_f%fill )  THEN
-                      surf_lsm_h%rho_c_total_def(k,m) =                           &
-                          pavement_subsurface_pars_f%pars_xyz(ind_p_rho_c,k,j,i)
-                   ENDIF
-                ENDDO
-
-             ENDIF
+             ENDDO
           ENDDO
           DO  l = 0, 3
@@ -4217,9 +4300,11 @@
 !--    the albedo type has been already given by the pars, albedo_type overwrites these values.
        IF ( albedo_type_f%from_file )  THEN
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-             IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                                   &
-                surf_lsm_h%albedo_type(m,:) = albedo_type_f%var(j,i)
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+                IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                                   &
+                   surf_lsm_h(l)%albedo_type(m,:) = albedo_type_f%var(j,i)
+             ENDDO
           ENDDO
           DO  l = 0, 3
@@ -4244,13 +4329,15 @@
 !--       data provided from input file contains fill values at some locations.
 !--       Level 1, initialization via profiles given in parameter file
-          DO  m = 1, surf_lsm_h%ns
-             IF ( surf_lsm_h%vegetation_surface(m)  .OR.                       &
-                  surf_lsm_h%pavement_surface(m) )  THEN
-                DO  k = nzb_soil, nzt_soil
-                   t_soil_h%var_2d(k,m) = soil_temperature(k)
-                   m_soil_h%var_2d(k,m) = soil_moisture(k)
-                ENDDO
-                t_soil_h%var_2d(nzt_soil+1,m) = deep_soil_temperature
-             ENDIF
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                IF ( surf_lsm_h(l)%vegetation_surface(m)  .OR.                       &
+                     surf_lsm_h(l)%pavement_surface(m) )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      t_soil_h(l)%var_2d(k,m) = soil_temperature(k)
+                      m_soil_h(l)%var_2d(k,m) = soil_moisture(k)
+                   ENDDO
+                   t_soil_h(l)%var_2d(nzt_soil+1,m) = deep_soil_temperature
+                ENDIF
+             ENDDO
           ENDDO
           DO  l = 0, 3
